from structio.core.task import Task
from structio.core.policies.fifo import FIFOPolicy


class LIFOPolicy(FIFOPolicy):
    """
    A last-in, first out scheduling policy
    """

    def __init__(self):
        super().__init__()
        # We redefine it as a list because we
        # have a different queueing policy
        self.run_queue: list[Task] = []

    def get_next_task(self) -> Task | None:
        if not self.run_queue:
            return None
        return self.run_queue.pop()

    def peek_next_task(self) -> Task | None:
        if not self.has_next_task():
            return
        return self.run_queue[-1]
