from structio.io.socket import socketpair
import signal


class WakeupFd:
    """
    A thin wrapper over a socket pair used in signal.set_wakeup_fd
    and for thread wakeup events
    """

    def __init__(self):
        self.reader, self.writer = socketpair()

    def set_wakeup_fd(self):
        signal.set_wakeup_fd(self.writer.socket.fileno())

    def wakeup(self):
        try:
            self.writer.socket.send(b"\x00")
        except BlockingIOError:
            pass
